package gui;


import processing.core.*;
import fullscreen.*;  //um im Vollbildmodus starten zu können.

import engine.Engine;

public class GUI extends PApplet
{
    public int x=0;
    public int y=200;
    
    public int BREITE;
    public int HOEHE;
    public int XOFF;
    public int YOFF;
    public int RAND=40;
    
    public int KACHELBREITE;
    public int XOFF_FELD;
    public int YOFF_FELD;
    
    public Engine engine;
    
    public void setup()
    {
        int minwert = displayWidth;
        if(displayHeight<minwert)
            minwert = displayHeight;
        BREITE = minwert - 2*RAND;
        HOEHE  = minwert - 2*RAND;
        XOFF   = displayWidth/2-BREITE/2;
        YOFF   = displayHeight/2-HOEHE/2;
    
        //Das Spielfeld soll in der unteren Bildschirmhälfte gezeichnet werden.
        //Die obere Hälfte soll für spezille Anzeigen reserviert bleiben.
        KACHELBREITE = (HOEHE/2)/3;
        XOFF_FELD = displayWidth/2 - (KACHELBREITE*3)/2;
        YOFF_FELD = YOFF + HOEHE/2;
                
        //Liniendicke an Bildgroesse anpassen:
        strokeWeight((float)BREITE*0.01f);
        
        engine = new Engine();
        
        size(displayWidth,displayHeight);
        frameRate(10);
        (new FullScreen(this)).enter();                 
    }

    private void zeichneSpielfeld()
    {
        noStroke();
        fill(150,150,255);
        for(int i=0;i<3;i++)
            for(int k=0;k<3;k++)
                rect(XOFF_FELD+k*KACHELBREITE,YOFF_FELD+i*KACHELBREITE,KACHELBREITE,KACHELBREITE);
        noFill();
        stroke(0);
        for(int i=0;i<3;i++)
            for(int k=0;k<3;k++)
                rect(XOFF_FELD+k*KACHELBREITE,YOFF_FELD+i*KACHELBREITE,KACHELBREITE,KACHELBREITE);
    }
    
    public void draw()
    {
        clear();
        background(200,200,200);
        zeichneSpielfeld();
    }

    public void mouseClicked()
    {
        y=mouseY;
    }

    public static void main(String[] passedArgs) 
    {
        String[] appletArgs = new String[] { "gui.GUI" };
        if(passedArgs != null) 
        {
             PApplet.main(concat(appletArgs, passedArgs));
        } 
        else 
        {
            PApplet.main(appletArgs);
        }            
    }
    
}
