package gui;

import gui.GUI;
import engine.Engine;
import strategie.Strategie;
import kiba.betriebssystem.Linuxsystem;
import kiba.hilfsklassen.Pause;

public class HAL implements Runnable
{
    private GUI gui;
    private Engine engine;
    private Linuxsystem linuxsystem;
    private Pause pause;
    
    int ZEIT = 0;
    int ZEITGEGNER = 0;
    int SPIELANZAHL = 0; //bereits durchgeführte Spiele
    int GEWONNEN_HAL = 0;
    int GEWONNEN_GEGNER = 0;
    
    int WARTEZEIT = 20; //Zehntelsekunden
    
    private void sprich(String text)
    {
        linuxsystem.syst("espeak -s100 -k20 -v mb-de7 \""+text+"\"");
    }
    
    public HAL(GUI gui, Engine engine)
    {
        this.gui = gui;
        this.engine = engine;
        pause = new Pause();
        linuxsystem = new Linuxsystem();
        
        (new Thread(this)).start();
    }

    public void run()
    {
        while(true)
        {
            if(gui.istDranHal())
            {
                ZEIT++;
                ZEITGEGNER=0;
            }
            else
            {
                ZEITGEGNER++;
                ZEIT=0;
            }
            
            try
            {
                Thread.sleep(100);
            }
            catch(Exception e)
            {
            }
            
            if(gui.istDranHal() && ZEIT>WARTEZEIT)
            {
                engine.setzeAutomatischOptimal();                
                gui.toggleHalIstDran();
                
                int gewonnen = engine.pruefeGewonnen();
                
                if(gewonnen==2)
                {
                    SPIELANZAHL++; //bereits durchgeführte Spiele
                    GEWONNEN_HAL++;
                    sprich("Ich habe gewonnen.");
                    pause.millis(3000);
                    sprich("Ich bereite jetzt ein neues Spiel vor.");
                    pause.millis(1000);
                    engine.initialisieren();
                }
                else if(gewonnen==1)
                {
                    SPIELANZAHL++; //bereits durchgeführte Spiele
                    GEWONNEN_GEGNER++;
                    
                    sprich("Du hast gewonnen.");
                    pause.millis(3000);
                    sprich("Ich bereite jetzt ein neues Spiel vor.");
                    pause.millis(1000);
                    engine.initialisieren();
                }
                else if(engine.pruefeVoll())
                {
                    SPIELANZAHL++; //bereits durchgeführte Spiele
                    sprich("Unentschieden.");                    
                    pause.millis(3000);
                    sprich("Ich bereite jetzt ein neues Spiel vor.");
                    pause.millis(1000);
                    engine.initialisieren();
                }
            }
        }
    }
}
