package gui;

import java.util.Random;

import processing.core.*;
import fullscreen.*;  //um im Vollbildmodus starten zu können.

import engine.Engine;
import gui.HAL;

public class GUI extends PApplet
{
    private Random zufall = new Random(System.currentTimeMillis());
    
    private boolean HAL_IST_DRAN = false;
    
    public int AUGEN=0;
    public int MUND=0;
    private boolean SPRICHT = false;
    
    public int x=0;
    public int y=200;
    
    public int BREITE;
    public int HOEHE;
    public int XOFF;
    public int YOFF;
    public int RAND=40;
    
    public int KACHELBREITE;
    public int XOFF_FELD;
    public int YOFF_FELD;
    
    public int MARGIN; //Lücke
    
    private Engine engine;
    private HAL hal;
    
    private PImage bildgesicht;
    
    public synchronized boolean istDranHal()
    {
        return HAL_IST_DRAN;
    }
    
    public synchronized void toggleHalIstDran()
    {
        HAL_IST_DRAN = !HAL_IST_DRAN;
    }
    
    public void setzeStimmung(int stimmung)
    {
        switch(stimmung)
        {
            case 0:
                AUGEN=0;
                MUND=0;
            break;
            case 1:
                AUGEN=1;
                MUND=1;
            break;
            case 2:
                AUGEN=2;
                MUND=2;
            break;
            default:
                AUGEN=0;
                MUND=0;
            break;
        }
    }
    
    public synchronized void toggleSpricht()
    {
        SPRICHT = !SPRICHT;
    }
    
    public void setup()
    {
        int minwert = displayWidth;
        if(displayHeight<minwert)
            minwert = displayHeight;
        BREITE = minwert - 2*RAND;
        HOEHE  = minwert - 2*RAND;
        XOFF   = displayWidth/2-BREITE/2;
        YOFF   = displayHeight/2-HOEHE/2;
    
        //Das Spielfeld soll in der unteren Bildschirmhälfte gezeichnet werden.
        //Die obere Hälfte soll für spezille Anzeigen reserviert bleiben.
        KACHELBREITE = (HOEHE/2)/3;
        XOFF_FELD = displayWidth/2 - (KACHELBREITE*3)/2;
        YOFF_FELD = YOFF + HOEHE/2;

        MARGIN = BREITE/100;
        
        //Liniendicke an Bildgroesse anpassen:
        strokeWeight((float)BREITE*0.01f);
        
        engine = new Engine();
        
        hal = new HAL(this,engine);
        
        bildgesicht = loadImage("gesicht.png");
        
        size(displayWidth,displayHeight);
        frameRate(20);
        (new FullScreen(this)).enter();                 
    }

    private void zeichneKreuz(int zeile, int spalte) //entspricht 1
    {
        noFill();
        stroke(255,0,0);
        int x1 = XOFF_FELD+spalte*KACHELBREITE+MARGIN;
        int y1 = YOFF_FELD+zeile*KACHELBREITE+MARGIN;
        int x2 = XOFF_FELD+(spalte+1)*KACHELBREITE-MARGIN;
        int y2 = YOFF_FELD+(zeile+1)*KACHELBREITE-MARGIN;
        line(x1,y1,x2,y2);
        int x3 = XOFF_FELD+(spalte+1)*KACHELBREITE-MARGIN;
        int y3 = YOFF_FELD+zeile*KACHELBREITE+MARGIN;
        int x4 = XOFF_FELD+spalte*KACHELBREITE+MARGIN;
        int y4 = YOFF_FELD+(zeile+1)*KACHELBREITE-MARGIN;
        line(x3,y3,x4,y4);
    }

    private void zeichneKreis(int zeile, int spalte) //entspricht 2
    {
        noFill();
        stroke(0,255,0);
        int x1 = XOFF_FELD+spalte*KACHELBREITE+KACHELBREITE/2;
        int y1 = YOFF_FELD+zeile*KACHELBREITE+KACHELBREITE/2;
        ellipse(x1,y1,KACHELBREITE-2*MARGIN,KACHELBREITE-2*MARGIN);
    }
    
    private void zeichneSperre(int zeile, int spalte)
    {
        noStroke();
        fill(0,0,255);
        int x1 = XOFF_FELD+spalte*KACHELBREITE+MARGIN;
        int y1 = YOFF_FELD+zeile*KACHELBREITE+MARGIN;
        int x2 = XOFF_FELD+(spalte+1)*KACHELBREITE-MARGIN;
        int y2 = YOFF_FELD+(zeile+1)*KACHELBREITE-MARGIN;
//UNSICHTBAR!        
//        rect(x1,y1,x2-x1,y2-y1);
    }
    
    private void zeichneSpielfeld()
    {
        noStroke();
        fill(200,200,255);
        for(int i=0;i<3;i++)
            for(int k=0;k<3;k++)
                rect(XOFF_FELD+k*KACHELBREITE,YOFF_FELD+i*KACHELBREITE,KACHELBREITE,KACHELBREITE);
        noFill();
        stroke(0);
        for(int i=0;i<3;i++)
            for(int k=0;k<3;k++)
                rect(XOFF_FELD+k*KACHELBREITE,YOFF_FELD+i*KACHELBREITE,KACHELBREITE,KACHELBREITE);
    }
    
    private void zeichneSpielfeldzustand()
    {
        for(int i=0;i<3;i++)
        {
            for(int k=0;k<3;k++)
            {
                int wert = engine.holeZustand(i,k);
                if(wert==1)
                    zeichneKreuz(i,k);
                else if(wert==2)
                    zeichneKreis(i,k);
                else if(wert==3)
                    zeichneSperre(i,k);
            }
        }            
        
    }
    
    public void zeichneAugen()
    {
        int gross = 5;
        switch(AUGEN)
        {
            case 0:
                noStroke();
                fill(0);
                gross = 5;
                ellipse(displayWidth/2-23,YOFF+100,gross,gross);
                ellipse(displayWidth/2+23+3,YOFF+100,gross,gross);
            break;
            case 1:
                noStroke();
                fill(0);
                gross = 5;
                ellipse(displayWidth/2-23,YOFF+100-2,gross,gross);
                ellipse(displayWidth/2+23+3,YOFF+100-2,gross,gross);
            break;
            case 2:
                noStroke();
                fill(0);
                gross = 5;
                ellipse(displayWidth/2-23,YOFF+100+2,gross,gross);
                ellipse(displayWidth/2+23+3,YOFF+100+2,gross,gross);
            break;
            default:
                noStroke();
                fill(0);
                gross = 5;
                ellipse(displayWidth/2-23,YOFF+100,gross,gross);
                ellipse(displayWidth/2+23+2,YOFF+100,gross,gross);
            break;
        }
    }
    public void zeichneMund()
    {
      if(SPRICHT)
      {
        switch(MUND)
        {
            case 0:
                noStroke();
                fill(0);
                if(SPRICHT && zufall.nextBoolean())
                    fill(255,0,0);
                
                rect(displayWidth/2-10+2,YOFF+170,20,10);
            break;
            default:
                noStroke();
                fill(0);
                if(SPRICHT && zufall.nextBoolean())
                    fill(255,0,0);
                rect(displayWidth/2-10+2,YOFF+170,20,10);
            break;
        }
      }
      else
      {
        switch(MUND)
        {
            case 0:
                noStroke();
                fill(0);
                if(SPRICHT && zufall.nextBoolean())
                    fill(255,0,0);
                
                rect(displayWidth/2-10+2,YOFF+170,20,10);
            break;
            case 1:

                noFill();
                stroke(0);
                line(displayWidth/2-10+2,YOFF+170,
                     displayWidth/2+0+2,YOFF+175);
                line(displayWidth/2+10+2,YOFF+170,
                     displayWidth/2+0+2,YOFF+175);
                     
            break;
            case 2:
                noFill();
                stroke(0);
                line(displayWidth/2-10+2,YOFF+170,
                     displayWidth/2+0+2,YOFF+165);
                line(displayWidth/2+10+2,YOFF+170,
                     displayWidth/2+0+2,YOFF+165);

            break;
            default:
                noStroke();
                fill(0);
                if(SPRICHT && zufall.nextBoolean())
                    fill(255,0,0);
                rect(displayWidth/2-10+2,YOFF+170,20,10);
            break;
        }
      }
    }
    
    public void draw()
    {
        clear();
        background(255,255,255);
        set(displayWidth/2-174/2,YOFF,bildgesicht);
        zeichneSpielfeld();
        zeichneSpielfeldzustand();
        zeichneAugen();
        zeichneMund();
    }

    public void mouseClicked()
    {
        //Prüfen, ob innerhalb des Spielfeldes:
        if(mouseX>=XOFF_FELD && mouseX<=XOFF_FELD+3*KACHELBREITE
        && mouseY>=YOFF_FELD && mouseY<=YOFF_FELD+3*KACHELBREITE
        && !istDranHal()
           )
        {
            int spalte  = (mouseX-XOFF_FELD)/KACHELBREITE;
            int zeile   = (mouseY-YOFF_FELD)/KACHELBREITE;
            if(!engine.istGesperrt(zeile,spalte))
            {
                engine.setzeManuell(zeile,spalte);            
                toggleHalIstDran();
            }
            else
            {
                hal.sprich("Dieses Feld ist vorübergehend gesperrt.");
            }
        }
    }

    public static void main(String[] passedArgs) 
    {
        String[] appletArgs = new String[] { "gui.GUI" };
        if(passedArgs != null) 
        {
             PApplet.main(concat(appletArgs, passedArgs));
        } 
        else 
        {
            PApplet.main(appletArgs);
        }            
    }
    
}
