package gui;

import java.util.Random;

import gui.GUI;
import engine.Engine;
import strategie.Strategie;
import kiba.betriebssystem.Linuxsystem;
import kiba.hilfsklassen.Pause;

public class HAL implements Runnable
{
    private Random zufall = new Random(System.currentTimeMillis());
    
    private GUI gui;
    private Engine engine;
    private Linuxsystem linuxsystem;
    private Pause pause;
    
    int ZEIT = 0;
    int ZEITGEGNER = 0;
    int SPIELANZAHL = 0; //bereits durchgeführte Spiele
    int GEWONNEN_HAL = 0;
    int GEWONNEN_GEGNER = 0;
    
    int WARTEZEIT = 20; //Zehntelsekunden
    
    public void sprich(String text)
    {
        gui.toggleSpricht();
        linuxsystem.syst("espeak -s100 -k20 -v mb-de7 \""+text+"\"");
        gui.toggleSpricht();
    }
    
    public HAL(GUI gui, Engine engine)
    {
        this.gui = gui;
        this.engine = engine;
        pause = new Pause();
        linuxsystem = new Linuxsystem();
        
        (new Thread(this)).start();
    }

    public void run()
    {
        while(true)
        {
            if(gui.istDranHal())
            {
                ZEIT++;
                ZEITGEGNER=0;
            }
            else
            {
                ZEITGEGNER++;
                ZEIT=0;
            }
            
            if(ZEITGEGNER==120)
            {
                gui.setzeStimmung(2);
                sprich("Langsam könntest Du mal setzen.");
                gui.setzeStimmung(0);
            }
            
            try
            {
                Thread.sleep(100);
            }
            catch(Exception e)
            {
            }

            if(gui.istDranHal() && ZEIT==WARTEZEIT/2)
            {
                double chance = engine.berechneChance();
                if(chance>0.0)
                {
                    if(chance>0.8)
                        gui.setzeStimmung(1);
                    else if(chance<0.2)
                        gui.setzeStimmung(2);
                    else    
                        gui.setzeStimmung(0);
                }
                else
                {
                        gui.setzeStimmung(0);
                }
            }
            
            if(gui.istDranHal() && ZEIT>WARTEZEIT)
            {
                engine.entsperreAlles();
                
                engine.setzeAutomatischOptimal(0);   //immer optimal
                //engine.setzeAutomatischOptimal(SPIELANZAHL);  //Tricks und fehler einbauen ab zweitem Spiel.             
                gui.toggleHalIstDran();

                
                int gewonnen = engine.pruefeGewonnen();
                
                if(gewonnen==2)
                {
                    SPIELANZAHL++; //bereits durchgeführte Spiele
                    GEWONNEN_HAL++;
                    gui.setzeStimmung(1);
                    sprich("Ich habe gewonnen.");
                    gui.setzeStimmung(0);
                    pause.millis(3000);
                    gui.setzeStimmung(0);                    
                    sprich("Ich bereite jetzt ein neues Spiel vor.");
                    pause.millis(1000);
                    engine.initialisieren();
                }
                else if(gewonnen==1)
                {
                    SPIELANZAHL++; //bereits durchgeführte Spiele
                    GEWONNEN_GEGNER++;
                    gui.setzeStimmung(2);
                    sprich("Du hast gewonnen.");
                    gui.setzeStimmung(0);
                    pause.millis(3000);
                    gui.setzeStimmung(0);                    
                    sprich("Ich bereite jetzt ein neues Spiel vor.");
                    pause.millis(1000);
                    engine.initialisieren();
                }
                else if(engine.pruefeVoll())
                {
                    SPIELANZAHL++; //bereits durchgeführte Spiele
                    sprich("Unentschieden.");                    
                    pause.millis(3000);
                    gui.setzeStimmung(0);                    
                    sprich("Ich bereite jetzt ein neues Spiel vor.");
                    pause.millis(1000);
                    engine.initialisieren();
                }
            }
        }
    }
}
